<?php

use Drp\NativeEventApp\Enums\NotificationStatus;
use Drp\NativeEventApp\Enums\NotificationType;
use Drp\NativeEventApp\Migrations\TableMigration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateNotificationsTable extends TableMigration
{
    public function tableName(): string
    {
        return 'notifications';
    }

    public function up(): void
    {
        Schema::create(
            $this->getTableNameWithPrefix(),
            static function (Blueprint $table): void {
                $table->bigIncrements('id');
                $table->unsignedInteger('event_id');
                $table->string('status')->default(NotificationStatus::DRAFT);
                $table->string('title')->default('');
                $table->text('message')->default('');
                $table->dateTime('send_at')->nullable();
                $table->dateTime('sent_at')->nullable();
                $table->unsignedInteger('total_sent')->default(0);
                $table->timestamps();
            }
        );
    }

    public function down(): void
    {
        Schema::drop($this->getTableNameWithPrefix());
    }
}
