<?php

namespace Drp\NativeEventApp\Auth;

use Drp\NativeEventApp\Enums\AuthMethod;

trait HasAuthMethods
{
    public function contactDetails(): ContactDetails
    {
        return new ContactDetails([
            new ContactDetail(AuthMethod::SMS(), $this->phone),
            new ContactDetail(AuthMethod::EMAIL(), $this->emailAddress),
        ]);
    }

    public function routeNotificationForMail(): string
    {
        return (string) $this->contactDetails()->get(AuthMethod::EMAIL());
    }

    public function routeNotificationForNexmo(): string
    {
        return $this->contactDetails()->get(AuthMethod::SMS())->internationalized();
    }
}
