<?php

namespace Drp\NativeEventApp\Models;

use Drp\NativeEventApp\Database\TableName;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;
use Illuminate\Database\Eloquent\Relations\HasOne;

class Menu extends Model
{
    /** @var string */
    protected $table = 'menus';

    /** @var bool */
    public $timestamps = false;

    public function items(): BelongsToMany
    {
        return $this->belongsToMany(
            NavigatableItem::class,
            TableName::make('menu_items'),
            'menuId',
            'navigatableItemId'
        )->orderBy('order');
    }

    public function navigation(): HasOne
    {
        return $this->hasOne(Navigation::class, 'menuId');
    }
}
