<?php

namespace Drp\NativeEventApp\Modules\Types\Form;

use JsonSerializable;

class Option implements JsonSerializable
{
    /** @var string */
    private $label;

    /** @var string|null */
    private $value;

    public function __construct(string $label, ?string $value)
    {
        $this->label = $label;
        $this->value = $value;
    }

    public static function make(string $label, ?string $value): self
    {
        return new self($label, $value);
    }

    public static function fromArray(array $options): array
    {
        $parsedOptions = [];

        foreach ($options as $option) {
            $parsedOptions[] = self::make($option['label'], $option['value']);
        }

        return $parsedOptions;
    }

    public function jsonSerialize(): array
    {
        return ['label' => $this->label, 'value' => $this->value];
    }
}
