<?php

namespace Drp\NativeEventApp\Test\Unit\Modules;

use Carbon\Carbon;
use Drp\NativeEventApp\Facades\ModulesUnSerializer;
use Drp\NativeEventApp\Models\Agenda;
use Drp\NativeEventApp\Modules\Modules;
use Drp\NativeEventApp\Modules\Types\AgendaTimeline;
use Drp\NativeEventApp\Test\TestCase;
use Spatie\Snapshots\MatchesSnapshots;

class AgendaTimelineTest extends TestCase
{
    use MatchesSnapshots;

    protected function setUp(): void
    {
        parent::setUp();
        Carbon::setTestNow('1st January 2019');
    }

    /** @test */
    public function can_make_agenda_timeline()
    {
        $agenda = factory(Agenda::class)->create();
        $moduleA = AgendaTimeline::make($agenda);
        $moduleB = AgendaTimeline::make($agenda->id);

        $this->assertEquals($agenda->id, $moduleA->agendaId);
        $this->assertEquals($agenda->id, $moduleB->agendaId);
    }

    /** @test */
    public function can_serialize()
    {
        $agenda = factory(Agenda::class)->create();
        $module = AgendaTimeline::make($agenda);

        $modules = ModulesUnSerializer::getModulesFromString(json_encode(Modules::make([$module])));
        $this->assertCount(1, $modules);
        $this->assertInstanceOf(AgendaTimeline::class, $modules->first());
        $this->assertEquals($agenda->id, $modules->first()->agendaId);
    }
}
