<?php

namespace Drp\NativeEventApp\Test\Unit\Modules;

use Drp\NativeEventApp\Test\Support\Fakes\Modules\FakeModule;
use Drp\NativeEventApp\Test\TestCase;

class ModuleTest extends TestCase
{
    public function setUp(): void
    {
        //
    }

    /** @test */
    public function can_get_all_attributes()
    {
        $module = FakeModule::make('fake');
        $module->text = 'TEXT';
        $module->other = 'OTHER';
        $attributes = $module->getAttributes();
        $this->assertEquals([
            'text' => 'TEXT',
            'other' => 'OTHER',
            'styles' => [],
            'className' => [],
            'viewableBy' => [],
        ], $attributes);
    }

    /** @test */
    public function can_apply_styles()
    {
        $module = FakeModule::make('fake')
            ->styles(['container' => ['padding' => 16]])
            ->className('narrow');
        $attributes = $module->getAttributes();
        $this->assertEquals([
            'styles' => ['container' => ['padding' => 16]],
            'className' => ['narrow'],
            'viewableBy' => [],
            'text' => null,
            'other' => null,
        ], $attributes);
    }

    /** @test */
    public function class_name_can_be_an_array()
    {
        $module = FakeModule::make('fake')
            ->styles(['container' => ['padding' => 16]])
            ->className(['narrow', 'blue']);
        $attributes = $module->getAttributes();
        $this->assertEquals([
            'styles' => ['container' => ['padding' => 16]],
            'className' => ['narrow', 'blue'],
            'text' => null,
            'other' => null,
            'viewableBy' => [],
        ], $attributes);
    }
}
